#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct foto
{
	char ime_pr[50];
	int dani;
	char pol[10];
	int starost;
	struct foto *sledeci;
} foto;

#define novi(x) x=(foto*)malloc(sizeof(foto))

foto *formiraj(char *dat)
{
	foto *p,*temp,*pom;
	FILE *f; char s[50];
	
	p=NULL;
	
	if((f=fopen(dat,"r")) == NULL)
	{
		printf("Greska pri ucitavanju iz datoteke.\n");
		exit(0);
	}
	while(1)
	{
		novi(temp);
		if(!temp)
		{
			printf("Greska pri alokaciji memorije.\n");
			exit(0);
		}
		fgets(s,50,f);
		strtok(s,"\n");
		strcpy(temp->ime_pr,s);
		fscanf(f,"%d",&temp->dani);
		if(temp->dani > 30) break;
		fgetc(f);
		fgets(s,10,f);
		strtok(s,"\n");
		strcpy(temp->pol,s);
		fscanf(f,"%d",&temp->starost);
		fgetc(f);
		if(p == NULL)
		{
			temp->sledeci=NULL;
			p=temp;
		}
		else
		{
			pom=p;
			while(pom->sledeci) pom=pom->sledeci;
			pom->sledeci=temp;
			temp->sledeci=NULL;
		}
	}
	fclose(f);
	return p;
}

foto* ucitaj_posta(foto *p)
{
	foto *pom,*pom1,*pom2,*temp;
	int i=0,n=5; char s[50],s1[10];
	
	pom=p;
	
	printf("Unesite podatke pristigle postom.\n");
	for(i=0; i<n; i++)
	{
		novi(temp);
		if(!temp)
		{
			printf("Greska pri alokaciji memorije.\n");
			exit(0);
		}
		gets(s);
		strcpy(temp->ime_pr,s);
		scanf("%d",&temp->dani);
		gets(s1);
		strcpy(temp->pol,s1);
		scanf("%d",&temp->starost);
		getchar();
		if(temp->dani < pom->dani)
		{
			temp->sledeci=pom;
			pom=temp;
		}
		else
		{
			pom2=pom;
			pom1=pom->sledeci;
			while((pom1) && (pom1->dani < temp->dani))
			{
				pom2=pom1;
				pom1=pom1->sledeci;
			}
			temp->sledeci=pom2->sledeci;
			pom2->sledeci=temp;
		}	
	}
	return pom;
}

void stampaj(foto *p)
{
	while(p)
	{
		printf("%s %d %s %d\n", p->ime_pr,p->dani,p->pol,p->starost);
		p=p->sledeci;
	}
}

float procenat(foto *p)
{
	foto *pom; int svi=0,devojke=0;
	float procenat;
	
	pom=p;
	while(pom)
	{
		if(!strcmp(pom->pol,"ZENSKI")) devojke++;
		svi++;
		pom=pom->sledeci;
	}
	procenat=(devojke*100)/svi;
	return procenat;
}

int main(int argc, char* argv[])
{
	foto *p; float pr;
	
	p=formiraj(argv[1]);
	stampaj(p);
	
	p=ucitaj_posta(p);
	stampaj(p);
	
	pr=procenat(p);
	printf("%f\n",pr);
}
