#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct foto
{
	char *ime_prezime;
	int broj_dana;
	char *pol;
	int starost;
}FOTO;

typedef struct elektronska
{
	FOTO *podaci;
	struct elektronska *sledeci;
}LISTA;
/*
typedef struct posta
{
	FOTO *podaci;
	struct posta *sledeci;
	
}POSTA;
*/
#define novaFotografija(x) x = (FOTO *)malloc(sizeof(FOTO));
#define novaLista(x) x = (LISTA *)malloc(sizeof(LISTA));

void dodaj(LISTA **p, FOTO **q)
{
	LISTA *pom, *temp;
	novaLista(temp);
	if(!temp)
		perror("Greska pri alokaciji memorije\n");
	temp->podaci = *q;
	temp->sledeci = NULL;
	if(!(*p))
		*p = temp;
	else
	{
		temp->sledeci = *p;
		*p = temp; 
	}
}

LISTA *formiraj(FILE *f)
{
	LISTA *p = NULL;
	FOTO *q;
	char s[100];
	int ind = 1;
	while(ind)
	{
		novaFotografija(q);
		fgets(s,100,f);
		q->ime_prezime = (char *)malloc(strlen(s)+1);
		strcpy(q->ime_prezime,s);
		
		fscanf(f,"%d",&q->broj_dana);
		fgetc(f);
		
		if(q->broj_dana <= 30)
		{
			fgets(s,100,f);
			q->pol = (char *)malloc(strlen(s)+1);
			strcpy(q->pol,s);
			
			fscanf(f,"%d",&q->starost);
			fgetc(f);
			
			dodaj(&p,&q);
		}
		else ind = 0;
	}
	return p;
}


void Ispis(LISTA *p,FILE *f)
{
	if(p)
	{
		while(p)
		{
			fprintf(f,"%s",p->podaci->ime_prezime);
			fprintf(f,"%d\n",p->podaci->broj_dana);
			fprintf(f,"%s",p->podaci->pol);
			fprintf(f,"%d\n",p->podaci->starost);
			fprintf(f,"\n");
			p = p->sledeci;
		}
	}
	else printf("LISTA JE PRAZNA\n");
}



main(int argc, char *argv[])
{
	LISTA *p = NULL;
	FOTO *q;
	FILE *fin = fopen(argv[1],"r");
	FILE *fout = fopen(argv[2],"w");
	p = formiraj(fin);
	Ispis(p,fout);
}
